//	VFD [FIP9B8] _eXg
//	wt]xH쎺	http://jsdiy.webcrow.jp

/*
y|[gΉz	ATtiny85	x:݂Ȃ(PB5RESET) -:
bit		7	6	5	4		3		2		1	0
portB	x	x	*	BLANK	STROBE	USCK	DO	PWM		HV5812, USI-3(SPI)

yATtiny85z	yHV5812z
|-210|			| 1:--			--:28|
|VBBB|			| 2:--		DataIn:27|
>    |			|  :--			--:  |
|BBBG|			|13:BLANK	STROBE:16|
|534-|			|14:GND		CLOCK :15|

yq[Yrbgz(ftavrw.exe -rf)	Hoאݒ Lo:01100010(62), Hi:11011111(DF)
Low: 01100010 (62)
     ||||++++-- CKSEL[3:0] VXeNbNI
     ||++-- SUT[1:0] N
     |+-- CKOUT (0:CLKOɃVXeNbNo)
     +-- CKDIV8 NbNl (1:1/1, 0:1/8)

High:11011111 (DF)
     |||||+++-- BODLEVEL[2:0] (111:Off, 110:1.8, 101:2.7, 100:4.3, 011:2.3, 010:2.2, 001:1.9, 000:2)
     ||||+-- EESAVE (ChipEEPROM 0:ێ, 1:)
     |||+-- WDTON (WDT 0:펞ON, 1:ʏ)
     ||+-- SPIEN (1:ISP֎~, 0:ISP) HVŜ
     |+-- DWEN (On-ChipfobO 1:, 0:L)
     +-- RSTDISBL (RESETs 1:L, 0:(PORT))

Ext: -------1 (FF)
	        +-- SELFPRGEN f[^V[gQ
*/
/*
yrhz
Atmel Studio 7 (Version: 7.0.1931 - )
ATtiny85  1MHzi8MHz/8j
*/
/*
yXVz
2021/04	v0.10
	Program Memory Usage 	:	640 bytes   7.8 % Full
	Data Memory Usage 		:	74 bytes   14.5 % Full
	
2021/04	v0.20
	EtBgdpPWMo͂B
	Program Memory Usage 	:	648 bytes   7.9 % Full
	Data Memory Usage 		:	74 bytes   14.5 % Full

2021/05	v0.30
	E\[X𐮗B
	Program Memory Usage 	:	476 bytes   5.8 % Full
	Data Memory Usage 		:	28 bytes   5.5 % Full
*/

#include <avr/io.h>
#include <util/delay.h>
#include "vfdctrl.h"


//7ZO̕`
const uint8_t
			  //0GFEDCBA
	SegC_d	= 0b01011110,
	SegC_o	= 0b01011100,
	SegC_n	= 0b01010100,
	SegC_t	= 0b01111000,
	SegC_u	= 0b00011100,
	SegC_c	= 0b01011000,
	SegC_h	= 0b01110100,
	SegC_null	= 0b00000000;

//LZOg
typedef	enum
{
	SegM_dp			= 0b00000001,	//u.v_
	SegM_sweep		= 0b00000010,	//u,vJ}̃qQ
	SegM_apostrophe	= 0b00000100,	//u'vA|XgtB[
	SegM_half		= 0b00001000,	//ŏɂu12v	̉͊܂܂
	SegM_comma		= (SegM_dp | SegM_sweep),	//u,vJ}
	SegM_null		= 0b00000000
}
ESegMark;


int	main(void)
{
	uint8_t	grid;
	
	//|[gݒ
	DDRB	|=	(1 << PB0);		//PWMo
	
	//
	VFD_Init();
	
	//OC0AɍPWMݒ肷iVFD̃tBgdD/ARo[^IȎgj
	TCCR0A	= (1 << COM0A1) | (0 << COM0A0) | (1 << WGM01) | (1 << WGM00);	//WGM02,01,00 = 011:8bitPWM
	TCCR0B	= (0 << WGM02) | (0 << CS02) | (0 << CS01) | (1 << CS00);		//CS02,01,00 = 001:Ȃ
	OCR0A	= 0xE8;		//ׂēd𑪒肵ēKɒl߂
	
	//\VFDɃZbg	udon't,touch.v
	grid = 1;
	VFD_GridArray(grid++, SegC_d, SegM_null);
	VFD_GridArray(grid++, SegC_o, SegM_null);
	VFD_GridArray(grid++, SegC_n, SegM_null);
	VFD_GridArray(grid++, SegC_t, SegM_apostrophe | SegM_comma);
	VFD_GridArray(grid++, SegC_t, SegM_null);
	VFD_GridArray(grid++, SegC_o, SegM_null);
	VFD_GridArray(grid++, SegC_u, SegM_null);
	VFD_GridArray(grid++, SegC_c, SegM_null);
	VFD_GridArray(grid++, SegC_h, SegM_dp);
	
	//VFD\Ԃɂ
	VFD_DisplayOn();
	
	while (1)
	{
		VFD_DynamicDrive();
		_delay_ms(1);
	}

	return 0;
}
